Package org.lwjgl.util.glu

# Class GLUtessellatorCallbackAdapter

java.lang.Object
org.lwjgl.util.glu.GLUtessellatorCallbackAdapter

All Implemented Interfaces:
  `GLUtessellatorCallback`

public class GLUtessellatorCallbackAdapter extends Object implements GLUtessellatorCallback
The GLUtessellatorCallbackAdapter provides a default implementation of `GLUtessellatorCallback` with empty callback methods. This class can be extended to provide user defined callback methods.

Author:
  Eric Veach, July 1994, Java Port: Pepijn Van Eechhoudt, July 2003, Java Port: Nathan Parker Burg, August 2003

## Constructor Summary

Constructors
Constructor
Description
`GLUtessellatorCallbackAdapter()`

## Method Summary

Modifier and Type
Method
Description
`void`
`begin(int type)`
The begin callback method is invoked like
invalid reference

    glBegin

to indicate the start of a (triangle) primitive.
`void`
`beginData(int type, Object polygonData)`
The same as the `begin` callback method except that it takes an additional reference argument.
`void`
`combine(double[] coords, Object[] data, float[] weight, Object[] outData)`
The combine callback method is called to create a new vertex when the tessellation detects an intersection, or wishes to merge features.
`void`
`combineData(double[] coords, Object[] data, float[] weight, Object[] outData, Object polygonData)`
The same as the `combine` callback method except that it takes an additional reference argument.
`void`
`edgeFlag(boolean boundaryEdge)`
The edgeFlag callback method is similar to
invalid reference

    glEdgeFlag

.
`void`
`edgeFlagData(boolean boundaryEdge, Object polygonData)`
The same as the `edgeFlage` callback method except that it takes an additional reference argument.
`void`
`end()`
The end callback serves the same purpose as
invalid reference

    glEnd

.
`void`
`endData(Object polygonData)`
The same as the `end` callback method except that it takes an additional reference argument.
`void`
`error(int errnum)`
The error callback method is called when an error is encountered.
`void`
`errorData(int errnum, Object polygonData)`
The same as the `error` callback method except that it takes an additional reference argument.
`void`
`vertex(Object vertexData)`
The vertex callback method is invoked between the `begin` and `end` callback methods.
`void`
`vertexData(Object vertexData, Object polygonData)`
The same as the `vertex` callback method except that it takes an additional reference argument.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### GLUtessellatorCallbackAdapter

public GLUtessellatorCallbackAdapter()

## Method Details

### begin

public void begin(int type)
Description copied from interface: `GLUtessellatorCallback`
The begin callback method is invoked like
invalid reference

    glBegin

to indicate the start of a (triangle) primitive. The method takes a single argument of type int. If the GLU_TESS_BOUNDARY_ONLY property is set to GL_FALSE, then the argument is set to either GL_TRIANGLE_FAN, GL_TRIANGLE_STRIP, or GL_TRIANGLES. If the GLU_TESS_BOUNDARY_ONLY property is set to GL_TRUE, then the argument will be set to GL_LINE_LOOP.

Specified by:
  `begin` in interface `GLUtessellatorCallback`
Parameters:
  `type` - Specifics the type of begin/end pair being defined. The following values are valid: GL_TRIANGLE_FAN, GL_TRIANGLE_STRIP, GL_TRIANGLES or GL_LINE_LOOP.
See Also:
  - invalid reference

        gluTessCallback

  - `end`
  - `begin`

### edgeFlag

public void edgeFlag(boolean boundaryEdge)
Description copied from interface: `GLUtessellatorCallback`
The edgeFlag callback method is similar to
invalid reference

    glEdgeFlag

. The method takes a single boolean boundaryEdge that indicates which edges lie on the polygon boundary. If the boundaryEdge is GL_TRUE, then each vertex that follows begins an edge that lies on the polygon boundary, that is, an edge that separates an interior region from an exterior one. If the boundaryEdge is GL_FALSE, then each vertex that follows begins an edge that lies in the polygon interior. The edge flag callback (if defined) is invoked before the first vertex callback.

Since triangle fans and triangle strips do not support edge flags, the begin callback is not called with GL_TRIANGLE_FAN or GL_TRIANGLE_STRIP if a non-null edge flag callback is provided. (If the callback is initialized to null, there is no impact on performance). Instead, the fans and strips are converted to independent triangles.

Specified by:
  `edgeFlag` in interface `GLUtessellatorCallback`
Parameters:
  `boundaryEdge` - Specifics which edges lie on the polygon boundary.
See Also:
  - invalid reference

        gluTessCallback

  - `edgeFlagData`

### vertex

public void vertex(Object vertexData)
Description copied from interface: `GLUtessellatorCallback`
The vertex callback method is invoked between the `begin` and `end` callback methods. It is similar to
invalid reference

    glVertex3f

, and it defines the vertices of the triangles created by the tessellation process. The method takes a reference as its only argument. This reference is identical to the opaque reference provided by the user when the vertex was described (see
invalid reference

    gluTessVertex

).

Specified by:
  `vertex` in interface `GLUtessellatorCallback`
Parameters:
  `vertexData` - Specifics a reference to the vertices of the triangles created byt the tessellatin process.
See Also:
  - invalid reference

        gluTessCallback

  - `vertexData`

### end

public void end()
Description copied from interface: `GLUtessellatorCallback`
The end callback serves the same purpose as
invalid reference

    glEnd

. It indicates the end of a primitive and it takes no arguments.

Specified by:
  `end` in interface `GLUtessellatorCallback`
See Also:
  - invalid reference

        gluTessCallback

  - `begin`
  - `endData`

### error

public void error(int errnum)
Description copied from interface: `GLUtessellatorCallback`
The error callback method is called when an error is encountered. The one argument is of type int; it indicates the specific error that occurred and will be set to one of GLU_TESS_MISSING_BEGIN_POLYGON, GLU_TESS_MISSING_END_POLYGON, GLU_TESS_MISSING_BEGIN_CONTOUR, GLU_TESS_MISSING_END_CONTOUR, GLU_TESS_COORD_TOO_LARGE, GLU_TESS_NEED_COMBINE_CALLBACK or GLU_OUT_OF_MEMORY. Character strings describing these errors can be retrieved with the `gluErrorString` call.

The GLU library will recover from the first four errors by inserting the missing call(s). GLU_TESS_COORD_TOO_LARGE indicates that some vertex coordinate exceeded the predefined constant GLU_TESS_MAX_COORD in absolute value, and that the value has been clamped. (Coordinate values must be small enough so that two can be multiplied together without overflow.) GLU_TESS_NEED_COMBINE_CALLBACK indicates that the tessellation detected an intersection between two edges in the input data, and the GLU_TESS_COMBINE or GLU_TESS_COMBINE_DATA callback was not provided. No output is generated. GLU_OUT_OF_MEMORY indicates that there is not enough memory so no output is generated.

Specified by:
  `error` in interface `GLUtessellatorCallback`
Parameters:
  `errnum` - Specifics the error number code.
See Also:
  - invalid reference

        gluTessCallback

  - `errorData`

### combine

public void combine(double[] coords, Object[] data, float[] weight, Object[] outData)
Description copied from interface: `GLUtessellatorCallback`
The combine callback method is called to create a new vertex when the tessellation detects an intersection, or wishes to merge features. The method takes four arguments: an array of three elements each of type double, an array of four references, an array of four elements each of type float, and a reference to a reference.

The vertex is defined as a linear combination of up to four existing vertices, stored in data. The coefficients of the linear combination are given by weight; these weights always add up to 1. All vertex pointers are valid even when some of the weights are 0. coords gives the location of the new vertex.

The user must allocate another vertex, interpolate parameters using data and weight, and return the new vertex pointer in outData. This handle is supplied during rendering callbacks. The user is responsible for freeing the memory some time after

invalid reference

    gluTessEndPolygon

is called.

For example, if the polygon lies in an arbitrary plane in 3-space, and a color is associated with each vertex, the GLU_TESS_COMBINE callback might look like this:

             void myCombine(double[] coords, Object[] data,
                            float[] weight, Object[] outData)
             {
                MyVertex newVertex = new MyVertex();

                newVertex.x = coords[0];
                newVertex.y = coords[1];
                newVertex.z = coords[2];
                newVertex.r = weight[0]*data[0].r +
                              weight[1]*data[1].r +
                              weight[2]*data[2].r +
                              weight[3]*data[3].r;
                newVertex.g = weight[0]*data[0].g +
                              weight[1]*data[1].g +
                              weight[2]*data[2].g +
                              weight[3]*data[3].g;
                newVertex.b = weight[0]*data[0].b +
                              weight[1]*data[1].b +
                              weight[2]*data[2].b +
                              weight[3]*data[3].b;
                newVertex.a = weight[0]*data[0].a +
                              weight[1]*data[1].a +
                              weight[2]*data[2].a +
                              weight[3]*data[3].a;
                outData = newVertex;
             }

Specified by:
  `combine` in interface `GLUtessellatorCallback`
Parameters:
  `coords` - Specifics the location of the new vertex.
  `data` - Specifics the vertices used to create the new vertex.
  `weight` - Specifics the weights used to create the new vertex.
  `outData` - Reference user the put the coodinates of the new vertex.
See Also:
  - invalid reference

        gluTessCallback

  - `combineData`

- ### beginData

  public void beginData(int type, Object polygonData)
  Description copied from interface: `GLUtessellatorCallback`
  The same as the `begin` callback method except that it takes an additional reference argument. This reference is identical to the opaque reference provided when
  invalid reference

      gluTessBeginPolygon

  was called.
  Specified by:
    `beginData` in interface `GLUtessellatorCallback`
  Parameters:
    `type` - Specifics the type of begin/end pair being defined. The following values are valid: GL_TRIANGLE_FAN, GL_TRIANGLE_STRIP, GL_TRIANGLES or GL_LINE_LOOP.
    `polygonData` - Specifics a reference to user-defined data.
  See Also:
    - invalid reference

          gluTessCallback

    - `endData`
    - `begin`

- ### edgeFlagData

  public void edgeFlagData(boolean boundaryEdge, Object polygonData)
  Description copied from interface: `GLUtessellatorCallback`
  The same as the `edgeFlage` callback method except that it takes an additional reference argument. This reference is identical to the opaque reference provided when
  invalid reference

      gluTessBeginPolygon

  was called.
  Specified by:
    `edgeFlagData` in interface `GLUtessellatorCallback`
  Parameters:
    `boundaryEdge` - Specifics which edges lie on the polygon boundary.
    `polygonData` - Specifics a reference to user-defined data.
  See Also:
    - invalid reference

          gluTessCallback

    - `edgeFlag`

- ### vertexData

  public void vertexData(Object vertexData, Object polygonData)
  Description copied from interface: `GLUtessellatorCallback`
  The same as the `vertex` callback method except that it takes an additional reference argument. This reference is identical to the opaque reference provided when
  invalid reference

      gluTessBeginPolygon

  was called.
  Specified by:
    `vertexData` in interface `GLUtessellatorCallback`
  Parameters:
    `vertexData` - Specifics a reference to the vertices of the triangles created byt the tessellatin process.
    `polygonData` - Specifics a reference to user-defined data.
  See Also:
    - invalid reference

          gluTessCallback

    - `vertex`

- ### endData

  public void endData(Object polygonData)
  Description copied from interface: `GLUtessellatorCallback`
  The same as the `end` callback method except that it takes an additional reference argument. This reference is identical to the opaque reference provided when
  invalid reference

      gluTessBeginPolygon

  was called.
  Specified by:
    `endData` in interface `GLUtessellatorCallback`
  Parameters:
    `polygonData` - Specifics a reference to user-defined data.
  See Also:
    - invalid reference

          gluTessCallback

    - `beginData`
    - `end`

- ### errorData

  public void errorData(int errnum, Object polygonData)
  Description copied from interface: `GLUtessellatorCallback`
  The same as the `error` callback method except that it takes an additional reference argument. This reference is identical to the opaque reference provided when
  invalid reference

      gluTessBeginPolygon

  was called.
  Specified by:
    `errorData` in interface `GLUtessellatorCallback`
  Parameters:
    `errnum` - Specifics the error number code.
    `polygonData` - Specifics a reference to user-defined data.
  See Also:
    - invalid reference

          gluTessCallback

    - `error`

- ### combineData

  public void combineData(double[] coords, Object[] data, float[] weight, Object[] outData, Object polygonData)
  Description copied from interface: `GLUtessellatorCallback`
  The same as the `combine` callback method except that it takes an additional reference argument. This reference is identical to the opaque reference provided when
  invalid reference

      gluTessBeginPolygon

  was called.
  Specified by:
    `combineData` in interface `GLUtessellatorCallback`
  Parameters:
    `coords` - Specifics the location of the new vertex.
    `data` - Specifics the vertices used to create the new vertex.
    `weight` - Specifics the weights used to create the new vertex.
    `outData` - Reference user the put the coodinates of the new vertex.
    `polygonData` - Specifics a reference to user-defined data.
  See Also:
    - invalid reference

          gluTessCallback

    - `combine`